"use strict";

exports.__esModule = true;
exports.default = exports.TransientsShadow = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _akutils = require("akutils");

var _ObjectProperty2 = require("./ObjectProperty");

var _ObjectProperty3 = _interopRequireDefault(_ObjectProperty2);

var _Shadow2 = require("./Shadow");

var _Shadow3 = _interopRequireDefault(_Shadow2);

var _TransientProperty = require("./TransientProperty");

var _TransientProperty2 = _interopRequireDefault(_TransientProperty);

var _debug = require("./debug");

var _debug2 = _interopRequireDefault(_debug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var debug = (0, _debug2.default)(_debug.TransientKey);

/*

*/

var TransientsShadow = exports.TransientsShadow = function (_Shadow) {
	_inherits(TransientsShadow, _Shadow);

	function TransientsShadow() {
		_classCallCheck(this, TransientsShadow);

		return _possibleConstructorReturn(this, Object.getPrototypeOf(TransientsShadow).apply(this, arguments));
	}

	_createClass(TransientsShadow, [{
		key: "clear",
		value: function clear() {
			this.__().clear();
		}
	}, {
		key: "delete",
		value: function _delete(id) {
			this.$$()._keyed.removeProperty(id);
		}
	}, {
		key: "entries",
		value: function entries() {
			var _this2 = this;

			return (0, _akutils.iterateOver)(this.__().keys(), function (key) {
				return [key, _this2[key]];
			});
		}
	}, {
		key: "has",
		value: function has(id) {
			return this.__().has(id);
		}
	}, {
		key: "keys",
		value: function keys() {
			return (0, _akutils.iteratorFor)(this.__().keys());
		}
	}, {
		key: "set",
		value: function set(id, property) {
			(0, _akutils.assert)(function (a) {
				return a.is(id, "id must be specifeid for setting a transient property");
			});

			var trans = new _TransientProperty2.default(id, property);

			this.$$()._keyed.addProperty(id, trans);

			return trans;
		}
	}, {
		key: "sweep",
		value: function sweep() {
			var property = this.$$();
			var keys = property._keyed.keysArray();

			for (var i = 0, t; t = this[keys[i]]; i++) {
				if (!t.isLocked()) {
					this.delete(keys[i]);
				}
			}
		}
	}, {
		key: "values",
		value: function values() {
			var _this3 = this;

			return (0, _akutils.iterateOver)(this.__().keys(), function (key) {
				return _this3[key];
			});
		}
	}, {
		key: Symbol.iterator,
		value: function value() {
			return this.entries();
		}
	}, {
		key: "size",
		get: function get() {
			return this.__().size();
		}
	}]);

	return TransientsShadow;
}(_Shadow3.default);

var TransientsProperty = function (_ObjectProperty) {
	_inherits(TransientsProperty, _ObjectProperty);

	function TransientsProperty(id, property) {
		_classCallCheck(this, TransientsProperty);

		var _this4 = _possibleConstructorReturn(this, Object.getPrototypeOf(TransientsProperty).call(this, {}, false, true));

		_this4.setShadowClass(TransientsShadow);
		return _this4;
	}

	return TransientsProperty;
}(_ObjectProperty3.default);

exports.default = TransientsProperty;