"use strict";

exports.__esModule = true;
exports.default = createKeyedPropertyType;

var _KeyedProperty2 = require("./KeyedProperty");

var _KeyedProperty3 = _interopRequireDefault(_KeyedProperty2);

var _Shadow2 = require("./Shadow");

var _Shadow3 = _interopRequireDefault(_Shadow2);

var _StateType = require("./StateType");

var _StateType2 = _interopRequireDefault(_StateType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
	Creates an KeyedProperty subclass based on a custom Shadow type.
*/
function createKeyedPropertyType() {
	var shadowType = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
	var stateSpec = arguments[1];
	var specCallback = arguments[2];

	var ShadowClass;

	// get the shadow class
	if (typeof shadowType === 'function') {
		// shadow class passed into method
		ShadowClass = shadowType;
	} else {
		var CustomKeyedShadow = function (_Shadow) {
			_inherits(CustomKeyedShadow, _Shadow);

			function CustomKeyedShadow() {
				_classCallCheck(this, CustomKeyedShadow);

				return _possibleConstructorReturn(this, Object.getPrototypeOf(CustomKeyedShadow).apply(this, arguments));
			}

			return CustomKeyedShadow;
		}(_Shadow3.default);

		var proto = CustomKeyedShadow.prototype;
		var names = Object.getOwnPropertyNames(shadowType);
		var name, desc;

		for (var i = 0, len = names.length; i < len; i++) {
			name = names[i];
			desc = Object.getOwnPropertyDescriptor(shadowType, name);

			Object.defineProperty(proto, name, desc);
		}

		ShadowClass = CustomKeyedShadow;
	}

	// create the property subclass

	var CustomKeyedProperty = function (_KeyedProperty) {
		_inherits(CustomKeyedProperty, _KeyedProperty);

		function CustomKeyedProperty() {
			var initialState = arguments.length <= 0 || arguments[0] === undefined ? CustomKeyedProperty.stateSpec._initialState : arguments[0];
			var autoShadow = arguments.length <= 1 || arguments[1] === undefined ? CustomKeyedProperty.stateSpec._autoshadow : arguments[1];
			var readonly = arguments.length <= 2 || arguments[2] === undefined ? CustomKeyedProperty.stateSpec._readonly : arguments[2];

			_classCallCheck(this, CustomKeyedProperty);

			var _this2 = _possibleConstructorReturn(this, Object.getPrototypeOf(CustomKeyedProperty).call(this, initialState, autoShadow, readonly));

			_this2.setShadowClass(ShadowClass);
			return _this2;
		}

		return CustomKeyedProperty;
	}(_KeyedProperty3.default);

	// assign state spec if present to new Property subclass


	CustomKeyedProperty.stateSpec = stateSpec || new _StateType2.default(CustomKeyedProperty);

	if (specCallback) {
		specCallback(CustomKeyedProperty.stateSpec);
	}

	return CustomKeyedProperty;
}