"use strict";

exports.__esModule = true;
exports.default = shadowProperty;

var _akutils = require("akutils");

/*
	Function used by shaders to instantiate shadow implementation classes, subclasses of ShadowImpl.
*/
function shadowProperty(time, ImplClass, property, name, state, parent, shader, prev) {
	var impl = new ImplClass(time, property, name, state, parent, shader, prev);

	if (property.isReadonly()) {
		impl.setReadonly(true);
	}

	// set the current implementation
	property.setImpl(impl);

	impl.setupPropertyAccess();

	return impl;
}